#include <acknex.h>
#include <default.c>



#define FALSE 0
#define TRUE 1

#define SecondInTicks 16

//ini
#define MAXPLAYERS 4

#define NOPLAYERID -1
#define ORPHAN -1
#define INVALID -1

#define ATOMSPEED 30
#define ATOMROTATESPEED 20

//owner
#define OWNER_NONE 0
#define OWNER_PLAYER 1
#define OWNER_COMPUTER 2

//macros
#define new(TYPE) malloc(sizeof(TYPE))
#define delete(OBJECT) free(OBJECT)


//							clrB	clrG	clrR	lft	rght	fire	tclrB	tclrG	tclrR	txtX	txtY	Nstr	Nlen	NPosX	
var PlayerData[56]={	0,		255,	255,	0,		0,		59,	0,		255,	255,	15,	80,	0,		9,		5,			//Mr Yellow
							0	,	0,		255,	0,		0,		60,	0	,	0,		255,	15,	100,	9,		7,		175,		//Mr Red (ex Pink)
							255,	0,		0,		0,		0,		61,	255,	0,		0,		15,	120,	16,	7,		365,		//Mr Blue
							0,		255,	0,		0,		0,		62,	0,		255,	0,		15,	140,	23,	8,		515};		//Mr Green
							

#define PLAYERDATA_COLOUR 0
#define PLAYERDATA_KEYLEFT 3
#define PLAYERDATA_KEYRIGHT 4
#define PLAYERDATA_KEYFIRE 5
#define PLAYERDATA_TEXTCOLOUR 6
#define PLAYERDATA_TEXTX 9
#define PLAYERDATA_TEXTY 10
#define PLAYERDATA_NAMESTART 11
#define PLAYERDATA_NAMELENGTH 12
#define PLAYERDATA_NAMEPOSX 13
	#define MAXPLAYERDATA 14



	//Network Messages
#define NETWORK_NULL 0
#define NETWORK_REQUESTPLAYERSTRUCTS 1
#define NETWORK_UPDATEPLAYERSTRUCTS 2
#define NETWORK_STARTMATCH 3
#define NETWORK_REQUESTATOMCREATION 4
#define NETWORK_CREATEATOM 5
#define NETWORK_REQUESTTOSENDMESSAGE 6
#define NETWORK_POSTMESSAGE 7
#define NETWORK_STARTMAINMENU 8
#define NETWORK_EXITGAME 9

var vNetworkMessage = NETWORK_NULL;

var vNetworkParameter1;
var vNetworkParameter2;
var vNetworkParameter3;
var vNetworkParameter4;

STRING* sNetworkString="#500";

//prototypes
void CalculateAiMove();
void setHeuristicTemplates();
void debug_VisualGrid1();
void debug_VisualGrid2();
void EnterLineAtChatroom(char* line,COLOR* color);
void Chatroom();
void StartInGame();
void StartMainMenu();

typedef struct { 
  var alive, roundsWon, owner;//, clientId;
  //STRING* clientName;
} PLAYER;

PLAYER* Player[MAXPLAYERS];

PLAYER Player1;
PLAYER Player2;
PLAYER Player3;
PLAYER Player4;

STRING* sStaticPlayerText[MAXPLAYERS];
STRING* sTxtPlayer[MAXPLAYERS];

STRING* sStaticTxtPlayer1="Yellow Player";
STRING* sStaticTxtPlayer2="Red Player";
STRING* sStaticTxtPlayer3="Blue Player";
STRING* sStaticTxtPlayer4="Green Player";

STRING* Player1Name="#100";
STRING* Player2Name="#100";
STRING* Player3Name="#100";
STRING* Player4Name="#100";

STRING* clientNames[4];

STRING* TempString="#100";
BMAP* bMScreen;

BMAP* bPlayerTexture[MAXPLAYERS];

var activePlayers,MatchStarted;

int Rounds[5]={1,3,5,10,15};

var Rindex=1;

int AreaSize[6]={0,4,9,15,18,27};

var Aindex=2;

int AreaSizeXY[5][2];

int AtomsNum;

var PlayersTurn;

int GameInitiating;

#define GAMESTATE_NULL 0
#define GAMESTATE_MAINMENU 1
#define GAMESTATE_INGAME 2

int iGameState=GAMESTATE_NULL;

#define POS_X 0
#define POS_Y 1
#define POS_Z 2

#define SQUARESIZE 60

VECTOR* CENTERPOS={x=0;y=0;z=0;}

#define MAXSIZE_X 12
#define MAXSIZE_Y 12

void InitArraySizes()
{
	//Array Sizes
	AreaSizeXY[0][POS_X]=4;
	AreaSizeXY[0][POS_Y]=4;
	
	AreaSizeXY[1][POS_X]=6;
	AreaSizeXY[1][POS_Y]=6;

	AreaSizeXY[2][POS_X]=8;
	AreaSizeXY[2][POS_Y]=8;

	AreaSizeXY[3][POS_X]=10;
	AreaSizeXY[3][POS_Y]=10;

	AreaSizeXY[4][POS_X]=MAXSIZE_X;
	AreaSizeXY[4][POS_Y]=MAXSIZE_Y;
}

int FieldAtoms[MAXSIZE_X][MAXSIZE_Y];
int FieldOwners[MAXSIZE_X][MAXSIZE_Y];


int IM1_FieldAtoms[MAXSIZE_X][MAXSIZE_Y];
int IM1_FieldOwners[MAXSIZE_X][MAXSIZE_Y];

void CleanFieldArrays()
{	
	int i,j;
	
	for (i=0;i<MAXSIZE_X;i++)
		for (j=0;j<MAXSIZE_Y;j++)
		{
			FieldAtoms[i][j]=0;
			FieldOwners[i][j]=NOPLAYERID;
		}
}




//AI Variables

#define dArrayAtoms IM1_FieldAtoms
#define dArrayOwners IM1_FieldOwners


int IM2_FieldAtoms[MAXSIZE_X][MAXSIZE_Y];
int IM2_FieldOwners[MAXSIZE_X][MAXSIZE_Y];

#define dArrayAtoms2 IM2_FieldAtoms
#define dArrayOwners2 IM2_FieldOwners



#define QUEUE_SIZE 10000

var AddAtom_X_Queue[QUEUE_SIZE];
var AddAtom_Y_Queue[QUEUE_SIZE];
var AddAtom_pID_Queue[QUEUE_SIZE];



int IMh[100][10];	//Influence Map Heuristics Array. [Number of Heuristic values][Number of different heuristic sets]

#define hAtomsInCell_l 0
#define hAtomsInCell_h 1
#define hNeighborOwnedSquares_l 2
#define hNeighborOwnedSquares_h 3
#define hNeighborOwnedSquaresPenalty_l 4
#define hNeighborOwnedSquaresPenalty_h 5
#define hNeighborOwnedSquaresMinimum_l 6
#define hNeighborOwnedSquaresMinimum_h 7
#define hBorderedEdges_l 8
#define hBorderedEdges_h 9
#define hDiagonalNeighbors_l 10
#define hDiagonalNeighbors_h 11
#define hDiagonalNeighborsBonus_l 12
#define hDiagonalNeighborsBonus_h 13
#define hNextToOneNeighbors_l 14
#define hNextToOneNeighbors_h 15
#define hNextToOneNeighborsBonus_l 16
#define hNextToOneNeighborsBonus_h 17
#define hNoOpponentNeighbors_l 18
#define hNoOpponentNeighbors_h 19
#define hNoOpponentNeighborsExplodeBonus_l 20
#define hNoOpponentNeighborsExplodeBonus_h 21
#define hNeighborOpponentReadyToExplode_l 22
#define hNeighborOpponentReadyToExplode_h 23
#define hNeighborOpponentReadyToExplodeBonus_l 24
#define hNeighborOpponentReadyToExplodeBonus_h 25
#define hReadyToExplodeWithOpponentNeighbors_l 26
#define hReadyToExplodeWithOpponentNeighbors_h 27
#define hReadyToExplodeWithOpponentNeighborsBonus_l 28
#define hReadyToExplodeWithOpponentNeighborsBonus_h 29
#define hEnemyClosestToExplosionPenalty_l 30
#define hEnemyClosestToExplosionPenalty_h 31
#define hMeClosestToExplosionBonus_l 32
#define hMeClosestToExplosionBonus_h 33


#define HeuristicSet_Normal 0

//End of AI Variables



//Queue Datastructure


//Push a Value into the Queue
void Queue_Push(var* Queue,var Node)
{
	int i=0;
	
	while (Queue[i]!=INVALID) i++;
	Queue[i]=Node;
}

//Pull a Value from the Queue
var Queue_Pull(var* Queue)
{
	var pulled;
	var i=1;
	
	pulled=Queue[0];
	Queue[0]=INVALID;
	
	while (Queue[i]!=INVALID) 
	{
		Queue[i-1]=Queue[i];
		Queue[i]=INVALID;
		i+=1;
	}

	return (pulled);
}


//Returns TRUE if QUEUE is empty, and false othewise
var Queue_isEmpty(var* Queue)
{
	if (Queue[0]==INVALID) return (TRUE);
		else return (FALSE);
}

//End of Queue Datastructure


//Clears 'array' by replacing all cells with 'clearNum'
void clearArray(var* array,var arraySize,var cleanNum)
{
	var i=0;
	while (i<arraySize)
	{
		array[i]=cleanNum;
		i+=1;
	}
}



//Draw a 2d Line
void ix_draw_line2d(VECTOR* p_start,VECTOR* p_end,VECTOR* p_colour)
{
	VECTOR start;
	VECTOR end;
	VECTOR colour;
	
	vec_set(start,p_start);
	vec_set(end,p_end);
	vec_set(colour,p_colour);


	draw_line(p_start,NULL,100);
	draw_line(p_start,p_colour,100);
	draw_line(p_end,p_colour,100);
}




//Draw a 3d Line
void ix_draw_line3d(VECTOR* p_start,VECTOR* p_end,VECTOR* p_colour)
{
	VECTOR start;
	VECTOR end;
	VECTOR colour;
	
	vec_set(start,p_start);
	vec_set(end,p_end);
	vec_set(colour,p_colour);


	draw_line3d(p_start,NULL,100);
	draw_line3d(p_start,p_colour,100);
	draw_line3d(p_end,p_colour,100);
}



void Draw3dField(int fieldX, int fieldY, VECTOR* centerPos, var squaresize, VECTOR* color)
{
	VECTOR startPos;
	VECTOR endPos;
	
	int i;

	for (i=0;i<=fieldY;i++)
	{
		startPos.x=centerPos.x-((fieldX*squaresize)/2);
		startPos.y=centerPos.y-((fieldY*squaresize)/2)+(i*squaresize);
		startPos.z=0;
		
		endPos.x=centerPos.x+((fieldX*squaresize)/2);
		endPos.y=centerPos.y-((fieldY*squaresize)/2)+(i*squaresize);
		endPos.z=0;
		
		ix_draw_line3d(startPos,endPos,color);
	}
		
	for (i=0;i<=fieldX;i++)
	{
		startPos.x=centerPos.x-((fieldX*squaresize)/2)+(i*squaresize);
		startPos.y=centerPos.y-((fieldY*squaresize)/2);
		startPos.z=0;
		
		endPos.x=centerPos.x-((fieldX*squaresize)/2)+(i*squaresize);
		endPos.y=centerPos.y+((fieldY*squaresize)/2);
		endPos.z=0;
		
		ix_draw_line3d(startPos,endPos,color);
	}
}


int countAtoms(int par_playerId)
{
	int i,j;
	int AtomsCount=0;
	
	for (i=0;i<AreaSizeXY[Aindex][POS_X];i++)
		for (j=0;j<AreaSizeXY[Aindex][POS_Y];j++)
			if (FieldOwners[i][j]==par_playerId) AtomsCount+=FieldAtoms[i][j];
			
	return AtomsCount;
}

STRING* GetNameFromPlayer(var par_playerId,STRING* PlayerNames)
{
	return(str_trunc(str_clip(str_cpy(TempString,PlayerNames),PlayerData[par_playerId*MAXPLAYERDATA+PLAYERDATA_NAMESTART]),str_len(PlayerNames)-PlayerData[par_playerId*MAXPLAYERDATA+PLAYERDATA_NAMESTART]-PlayerData[par_playerId*MAXPLAYERDATA+PLAYERDATA_NAMELENGTH]));
}


void CreateTable()
{
	you=ent_createlocal("cube.mdl",vector(0,0,1),NULL);
	you.scale_x=500;
	you.scale_y=500;
	you.scale_z=0.05;
	
	c_setminmax(you);
	
	set(you,INVISIBLE);
}

void createDynamicLight(VECTOR* pos,var range,VECTOR* color)
{
	you=ent_createlocal("sphere.mdl",pos,NULL);
	
	 set(you,LIGHT|INVISIBLE);
	 you.lightrange = range;
	 vec_set(you.blue,color);
}


void createAtomTextures()
{
	int i;
	
	for (i=0;i<MAXPLAYERS;i++)
	{
		bPlayerTexture[i] = bmap_createblack(2,2,16);
		bmap_fill (bPlayerTexture[i],PlayerData[i*MAXPLAYERDATA+PLAYERDATA_TEXTCOLOUR],100);
	}
	
	you=ent_createlocal("sphere.mdl",nullvector,NULL);
	
	for (i=0;i<MAXPLAYERS;i++)
		ent_setskin(you,bPlayerTexture[i],i+1);
		
	ent_remove(you);
}

void CreateNewLevel()
{
	//Load Level
	level_load("cube.mdl");
	
	//Remove the dummy cube model
	you = ent_next(NULL); // retrieve first entity
	ent_remove(you);
	
	//Create Atom Textures
	createAtomTextures();
	
	//Sun Light & my lights
	sun_light = 0;
	createDynamicLight(vector(0,0,-600),1500,vector(128,128,128));
	
	//Create Backtable
	CreateTable();
}


var NextPlayerTurn(var currentPlayerTurn)
{
	if (currentPlayerTurn++>=MAXPLAYERS) currentPlayerTurn=0;
	
	while (Player[currentPlayerTurn]->owner==OWNER_NONE || Player[currentPlayerTurn]->alive==FALSE || countAtoms(currentPlayerTurn)==0)
		if (currentPlayerTurn++>=MAXPLAYERS) currentPlayerTurn=0;
		
	return currentPlayerTurn;
}



#define posx skill1
#define posy skill2
#define playerId skill3
#define order skill4
#define order_movetofield_posx skill5
#define order_movetofield_posy skill6
#define order_movetofield_percentage skill7
#define speed skill8
#define order_movetofield_startPosX skill9
#define order_movetofield_startPosY skill10
#define order_movetofield_startPosZ skill11
#define entityType skill12
#define angledist skill13
#define realposx skill14
#define realposy skill15
#define realposz skill16
#define rotatespeed skill17
#define movetoorbit_percentage skill18

#define ORDER_NULL 0
#define ORDER_MOVETOFIELD 1
#define ORDER_MOVETOORBIT 2
#define ORDER_ORBIT 3


#define ENTITYTYPE_NULL 0
#define ENTITYTYPE_ATOM 1



#define INSTRUCTION_NULL 0
#define INSTRUCTION_CHANGEOWNERSHIP 1
#define INSTRUCTION_MOVE 2



#define PLANE_X 0
#define PLANE_Y 1
#define PLANE_Z 2




void ArrayField_RemoveAtom(int posX,int posY)
{
	FieldAtoms[posX][posY]-=1;
	if (FieldAtoms[posX][posY]==0) FieldOwners[posX][posY]=NOPLAYERID;
}


void OrderAtomTo_Move(ENTITY* eAtom,int posX,int posY)
{
	eAtom.order=ORDER_MOVETOFIELD;
	eAtom.order_movetofield_posx=posX;
	eAtom.order_movetofield_posy=posY;
	eAtom.order_movetofield_percentage=0;
	vec_set(eAtom.order_movetofield_startPosX,eAtom.x);
	
	if (eAtom.posx!=ORPHAN && eAtom.posy!=ORPHAN) ArrayField_RemoveAtom(eAtom.posx,eAtom.posy);
		
	eAtom.posx=ORPHAN;
	eAtom.posy=ORPHAN;
}


int AreAtomsOnTheMove()
{	
	you = ent_next(NULL);
 	while (you)
	{ 
		if (you.entityType==ENTITYTYPE_ATOM)
		{
			if (you.order!=ORDER_ORBIT) return TRUE;
		}
		
 		you = ent_next(you);
 	}
 	
 	return FALSE;
}

void ModifyAtoms(int Instruction,var par1,var par2,var par3,var par4)
{
	you = ent_next(NULL);
 	while (you)
	{ 
		if (you.entityType==ENTITYTYPE_ATOM)
		{
			if (Instruction==INSTRUCTION_CHANGEOWNERSHIP)
			{
				if (you.posx==par1 && you.posy==par2)
				{
					you.playerId=par3;
					you.skin=par3+1;
				}
			}
			if (Instruction==INSTRUCTION_MOVE)
			{
				if (you.posx==par1 && you.posy==par2)
				{
					OrderAtomTo_Move(you,you.posx+par3,you.posy+par4);
					return;
				}
			}
		}
		
 		you = ent_next(you);
 	}
	
}

void ArrayField_AddAtom(int posX,int posY,int par_playerId)
{
	//Add one atom to the new field
	FieldAtoms[posX][posY]+=1;
	
	//If the new field was currently occupied by another player, or by no player
	if (FieldOwners[posX][posY]!=par_playerId)
	{
		if (FieldOwners[posX][posY]!=NOPLAYERID)
		{
			ModifyAtoms(INSTRUCTION_CHANGEOWNERSHIP,posX,posY,par_playerId,NULL);
		}
		
		FieldOwners[posX][posY]=par_playerId;
	}
	
	//If this field now has more atoms than it can afford
	int Overflow=0;
	if (posX==0) Overflow++;
	if (posY==0) Overflow++;
	if (posX==AreaSizeXY[Aindex][POS_X]-1) Overflow++;
	if (posY==AreaSizeXY[Aindex][POS_Y]-1) Overflow++;
	Overflow+=FieldAtoms[posX][posY];
	
	if (Overflow>3)
	{
		if (posX!=0) ModifyAtoms(INSTRUCTION_MOVE,posX,posY,-1,0);
		if (posY!=0) ModifyAtoms(INSTRUCTION_MOVE,posX,posY,0,-1);
		if (posX!=AreaSizeXY[Aindex][POS_X]-1) ModifyAtoms(INSTRUCTION_MOVE,posX,posY,1,0);
		if (posY!=AreaSizeXY[Aindex][POS_Y]-1) ModifyAtoms(INSTRUCTION_MOVE,posX,posY,0,1);
	}
}


void is_GetPosVecByRadious(VECTOR* SourcePos,angle,distance,int plane, VECTOR* ReturnedPos)
{
	if (plane==PLANE_X)
	{
		ReturnedPos.x=SourcePos.x; 
		ReturnedPos.y=distance*cos(angle)+SourcePos.y;
		ReturnedPos.z=distance*sin(angle)+SourcePos.z;
	}
	else if (plane==PLANE_Y)
	{
		ReturnedPos.x=distance*sin(angle)+SourcePos.x;
		ReturnedPos.y=SourcePos.y;
		ReturnedPos.z=distance*cos(angle)+SourcePos.z;
	}
	else if (plane==PLANE_Z)
	{
		ReturnedPos.x=distance*cos(angle)+SourcePos.x;
		ReturnedPos.y=distance*sin(angle)+SourcePos.y;
		ReturnedPos.z=SourcePos.z; 
	}
}



var is_CalcMidP_Direction[3];
void is_CalculateMidPoint(var* vStartVec,var* vEndVec,distanceFromStart,var* vResultVec)
{	
	//compute (StartVec-EndVec)/||(StartVec-EndVec|| 
	//to get normalized vector heading from StartVec to EndVec
	//vec_diff(is_CalcMidP_Direction,vStartVec,vEndVec);
	vec_diff(is_CalcMidP_Direction,vEndVec,vStartVec);
	vec_normalize(is_CalcMidP_Direction,1);
	
	//StartVec+distance*Direction to get MidPoint
	vec_scale(is_CalcMidP_Direction,distanceFromStart);
	
	
	vec_set(vResultVec,vStartVec);
		
	vec_add(vResultVec,is_CalcMidP_Direction);
}

var ix_ZeroToXScale(Avalue,MaxValue,X)
{
	//Prevent division by Zero
	if (MaxValue==0) {return(0);}
	
	//Return Value
	return (maxv(0,minv((Avalue/MaxValue)*X,X)));
}


var ix_percentage(Avalue,MaxValue)
{
	//Prevent division by Zero
	if (MaxValue==0) {return(0);}
	
	//Return Value
	return (maxv(0,minv((Avalue/MaxValue)*100,100)));
}

var ix_Random(from,to)
{
	return(from+random(to-from));
}


var ix_IntRandom(from,to)
{
	return(from+integer(random((to+1)-from)));
}


VECTOR* getPosFrom(int posX, int posY)
{
	static VECTOR returnPos;
	
	
	returnPos.x=CENTERPOS.x-((AreaSizeXY[Aindex][POS_X]*SQUARESIZE)/2)+posX*SQUARESIZE+SQUARESIZE/2;
	returnPos.y=CENTERPOS.y-((AreaSizeXY[Aindex][POS_Y]*SQUARESIZE)/2)+posY*SQUARESIZE+SQUARESIZE/2;
	returnPos.z=0;
	
	return &returnPos;
}


void AtomAction()
{
	VECTOR tempVec;
	int rotatePlane;
	
	wait(1); //wait for my createe function to set my skills
	
	while (1)
	{
		if (my.order==ORDER_MOVETOFIELD)
		{
			if (my.order_movetofield_percentage<100)
			{
				vec_set(tempVec,getPosFrom(my.order_movetofield_posx,my.order_movetofield_posy)); //Find real position that we need to move to
				
				//Move Me
				is_CalculateMidPoint(my.order_movetofield_startPosX, //startPos
											tempVec, //endPos
											ix_ZeroToXScale(my.order_movetofield_percentage,100,vec_dist(my.order_movetofield_startPosX,tempVec)),	//distanceSoFar
											my.x);	//resultVec
				
				my.order_movetofield_percentage=minv(my.order_movetofield_percentage+my.speed*time_step,100);
			}
			else
			{
				my.order=ORDER_MOVETOORBIT;
				my.posx=my.order_movetofield_posx;
				my.posy=my.order_movetofield_posy;
				vec_set(my.realposx,getPosFrom(my.posx,my.posy)); //Find real position (center of it's square) and store it for the orbiting
				my.angledist=0;
				my.movetoorbit_percentage=0;
				if (FieldAtoms[my.posx][my.posy]==0) rotatePlane=PLANE_Z;
					else if (FieldAtoms[my.posx][my.posy]==1) rotatePlane=PLANE_X;
						else rotatePlane=PLANE_Y;
				ArrayField_AddAtom(my.order_movetofield_posx,my.order_movetofield_posy,my.playerId); //needs to be last
			}
		}
		
		if (my.order==ORDER_MOVETOORBIT)
		{
			if (my.movetoorbit_percentage<100)
			{
				is_GetPosVecByRadious(my.realposx,my.angledist,SQUARESIZE*0.20,rotatePlane,tempVec);
				
				//Move Me
				is_CalculateMidPoint(my.realposx, //startPos
											tempVec, //endPos
											ix_ZeroToXScale(my.movetoorbit_percentage,100,vec_dist(my.realposx,tempVec)),	//distanceSoFar
											my.x);	//resultVec
				
				my.movetoorbit_percentage=minv(my.movetoorbit_percentage+my.speed*time_step,100);
			}
			else
			{
				my.order=ORDER_ORBIT;
			}
		}
		
		if (my.order==ORDER_ORBIT)
		{
			is_GetPosVecByRadious(my.realposx,my.angledist,SQUARESIZE*0.20,rotatePlane,my.x);
			
			my.angledist+=my.rotatespeed*time_step;
			if (my.angledist>360) my.angledist-=360;
		}
		
		wait(1);
	}
}


void CreateNewAtomAt(int posX,int posY,int par_playerId)
{
	int i;
	
	you=ent_createlocal("sphere.mdl",camera.x,AtomAction);
	
	you.scale_x=1.2;
	you.scale_y=you.scale_x;
	you.scale_z=you.scale_x;

	you.entityType=ENTITYTYPE_ATOM;
	you.skin=par_playerId+1;
	you.playerId=par_playerId;
	you.speed=ATOMSPEED;
	you.rotatespeed=ATOMROTATESPEED;
	you.posx=ORPHAN;
	you.posy=ORPHAN;
	
	OrderAtomTo_Move(you,posX,posY);
}




void HandleEscape()
{
	if (iGameState==GAMESTATE_INGAME)
	{
		if (connection!=2)
		{
			StartMainMenu();
			
			vNetworkMessage=NETWORK_STARTMAINMENU;
			send_var(vNetworkMessage);
			vNetworkMessage = NETWORK_NULL;
		}
	}
	else 
	{
		if (connection!=2) //if server/single
		{
			vNetworkMessage=NETWORK_EXITGAME;
			send_var(vNetworkMessage);
			vNetworkMessage = NETWORK_NULL;
			wait(3);
			sys_exit("");
		}
		else	//if client
		{
			sys_exit("");
		}
	}
}


void ToggleStart()
{
	if (iGameState==GAMESTATE_MAINMENU)
	{
		if (activePlayers<2)
		{ 
			//snd_play(sndCantStartGame,100,0);
			beep();
		}
		else
		{
			if (connection!=2)
			{
				StartInGame();
				
				vNetworkMessage=NETWORK_STARTMATCH;
				send_var(vNetworkMessage);
				vNetworkMessage = NETWORK_NULL;
			}
		}
	}
}


void client_event(void* str)
{
	if (event_type == EVENT_VAR)
	{
		if (connection==2)
		{
			if (vNetworkMessage==NETWORK_STARTMATCH)
			{
				StartInGame();
			}
			
			else if (vNetworkMessage==NETWORK_STARTMAINMENU)
			{
				StartMainMenu();
			}
			
			else if (vNetworkMessage==NETWORK_CREATEATOM)
			{
				CreateNewAtomAt(vNetworkParameter1,vNetworkParameter2,vNetworkParameter3);
				
				vNetworkParameter1=NETWORK_NULL;
				vNetworkParameter2=NETWORK_NULL;
				vNetworkParameter3=NETWORK_NULL;
			}
			
			else if (vNetworkMessage==NETWORK_POSTMESSAGE)
			{
				if (vNetworkParameter1==NOPLAYERID) EnterLineAtChatroom(sNetworkString,vector(255,255,255));
					else EnterLineAtChatroom(sNetworkString,PlayerData[vNetworkParameter1*MAXPLAYERDATA+PLAYERDATA_TEXTCOLOUR]);
				
				vNetworkParameter1=NETWORK_NULL;
				str_cpy(sNetworkString,"#500");
			}
			
			else if (vNetworkMessage==NETWORK_EXITGAME)
			{
				sys_exit("");
			}
			
			vNetworkMessage=NETWORK_NULL;
		}
	}
}



//TEXT* tJoin = { string(""); flags = SHOW; }


void server_event(void* str,var id)
{
	/*if (event_type == EVENT_JOIN)
	{
		//str_cpy((tJoin.pstring)[0],str); // contains the client's name
		//str_cat((tJoin.pstring)[0]," has just joined!");
	}
	else */if (event_type == EVENT_VAR)
	{
		if (vNetworkMessage==NETWORK_REQUESTPLAYERSTRUCTS)
		{
			int i=-1;
			while (i++<MAXPLAYERS)
			{
				send_var_id(id,Player[i]);
				send_string_id(id,clientNames[i]);
			}
			
			send_var_id(id,activePlayers);
		}
		
		else if (vNetworkMessage==NETWORK_UPDATEPLAYERSTRUCTS)
		{
			int i=-1;
			while (i++<MAXPLAYERS)
			{
				send_var(Player[i]);
				send_string(clientNames[i]);
			}
			
			send_var(activePlayers);
		}
		
		else if (vNetworkMessage==NETWORK_REQUESTATOMCREATION)
		{
			CreateNewAtomAt(vNetworkParameter1,vNetworkParameter2,vNetworkParameter3);
			
			vNetworkMessage=NETWORK_CREATEATOM;
			send_var(vNetworkParameter1);
			send_var(vNetworkParameter2);
			send_var(vNetworkParameter3);
			send_var(vNetworkMessage);
			
			vNetworkParameter1=NETWORK_NULL;
			vNetworkParameter2=NETWORK_NULL;
			vNetworkParameter3=NETWORK_NULL;
			
			PlayersTurn=NextPlayerTurn(PlayersTurn);
			send_var(PlayersTurn);
		}
		
		else if (vNetworkMessage==NETWORK_REQUESTTOSENDMESSAGE)
		{
			if (vNetworkParameter1==NOPLAYERID) EnterLineAtChatroom(sNetworkString,vector(255,255,255));
				else EnterLineAtChatroom(sNetworkString,PlayerData[vNetworkParameter1*MAXPLAYERDATA+PLAYERDATA_TEXTCOLOUR]);
			
			vNetworkMessage=NETWORK_POSTMESSAGE;
			
			send_var(vNetworkParameter1);
			send_string(sNetworkString);
			send_var(vNetworkMessage);
			
			vNetworkParameter1=NETWORK_NULL;
			str_cpy(sNetworkString,"#500");
		}
		
		
		vNetworkMessage=NETWORK_NULL;
	}
}




void TogglePlayer(int i)
{
	if ((Player[i]->owner==OWNER_NONE) || (Player[i]->owner==OWNER_PLAYER && str_cmpi(clientNames[i],player_name)) || (connection!=2 && Player[i]->owner==OWNER_COMPUTER))
	{
		if (Player[i]->owner==OWNER_NONE) activePlayers++;
		
		Player[i]->roundsWon=0;
		
		Player[i]->owner++;
		
		if (connection==2 && Player[i]->owner==OWNER_COMPUTER) Player[i]->owner++;
		
		if (Player[i]->owner>OWNER_COMPUTER)
		{
			Player[i]->owner=OWNER_NONE;
			activePlayers--;
		}
		
		if (Player[i]->owner==OWNER_PLAYER) str_cpy(clientNames[i],player_name);
			else str_cpy(clientNames[i], "#100");
			
		send_var(Player[i]);
		send_string(clientNames[i]);
		send_var(activePlayers);
		
		if (connection==2)
		{
			vNetworkMessage=NETWORK_UPDATEPLAYERSTRUCTS;
			send_var(vNetworkMessage);
			vNetworkMessage = NETWORK_NULL;
		}
	}
}


void Player1Button() {if (iGameState==GAMESTATE_MAINMENU) TogglePlayer(0);}
void Player2Button() {if (iGameState==GAMESTATE_MAINMENU) TogglePlayer(1);}
void Player3Button() {if (iGameState==GAMESTATE_MAINMENU) TogglePlayer(2);}
void Player4Button() {if (iGameState==GAMESTATE_MAINMENU) TogglePlayer(3);}


void HandleMouseLeft()
{
	if (iGameState==GAMESTATE_INGAME)
	{
		if (str_cmp(clientNames[PlayersTurn],player_name) && Player[PlayersTurn]->owner==OWNER_PLAYER && !AreAtomsOnTheMove())
		{
			VECTOR mouse_click;
			int PosX,PosY;
			
			vec_set (mouse_click, mouse_dir3d);
			vec_normalize(mouse_click, 5000);
			vec_add (mouse_click, camera.x);
			if (c_trace (camera.x, mouse_click, NULL)>0)
			{
				for (PosX=0;PosX<AreaSizeXY[Aindex][POS_X];PosX++)
					if (CENTERPOS.x-((AreaSizeXY[Aindex][POS_X]*SQUARESIZE)/2)+(PosX+1)*SQUARESIZE>target.x && target.x>CENTERPOS.x-((AreaSizeXY[Aindex][POS_X]*SQUARESIZE)/2)) break;
					
				for (PosY=0;PosY<AreaSizeXY[Aindex][POS_Y];PosY++)
					if (CENTERPOS.y-((AreaSizeXY[Aindex][POS_Y]*SQUARESIZE)/2)+(PosY+1)*SQUARESIZE>target.y && target.y>CENTERPOS.y-((AreaSizeXY[Aindex][POS_Y]*SQUARESIZE)/2)) break;
				
				if (PosX<AreaSizeXY[Aindex][POS_X] && PosY<AreaSizeXY[Aindex][POS_Y])
				{
					if (FieldOwners[PosX][PosY]==PlayersTurn || FieldAtoms[PosX][PosY]<=0)
					{
						if (connection==2)
						{
							vNetworkMessage=NETWORK_REQUESTATOMCREATION;
							vNetworkParameter1=PosX;
							vNetworkParameter2=PosY;
							vNetworkParameter3=PlayersTurn;
							
							send_var(vNetworkParameter1);
							send_var(vNetworkParameter2);
							send_var(vNetworkParameter3);
							send_var(vNetworkMessage);
							
							vNetworkMessage=NETWORK_NULL;
							vNetworkParameter1=NETWORK_NULL;
							vNetworkParameter2=NETWORK_NULL;
							vNetworkParameter3=NETWORK_NULL;
						}
						else
						{
							CreateNewAtomAt(PosX,PosY,PlayersTurn);
							
							vNetworkMessage=NETWORK_CREATEATOM;
							vNetworkParameter1=PosX;
							vNetworkParameter2=PosY;
							vNetworkParameter3=PlayersTurn;
							
							send_var(vNetworkParameter1);
							send_var(vNetworkParameter2);
							send_var(vNetworkParameter3);
							send_var(vNetworkMessage);
							
							vNetworkMessage=NETWORK_NULL;
							vNetworkParameter1=NETWORK_NULL;
							vNetworkParameter2=NETWORK_NULL;
							vNetworkParameter3=NETWORK_NULL;
							
							PlayersTurn=NextPlayerTurn(PlayersTurn);
							send_var(PlayersTurn);
						}
					}
				}
			}
		}
	}
}

/*
void HandleMouseRight()
{
	if (connection!=2)
	{
		PlayersTurn=NextPlayerTurn(PlayersTurn);
		send_var(PlayersTurn);
	}
}
*/


void ToggleRounds()
{
	if (connection!=2 && !MatchStarted)
	{
		Rindex++;
		if (Rindex>4) Rindex=0;
		send_var(Rindex);
	}
}

void ToggleAreaSize()
{
	if (connection!=2 && !MatchStarted)
	{
		Aindex++;
		if (Aindex>4) Aindex=0;
		send_var(Aindex);
	}
}

#define CHATROOM_MAXLINES 7
STRING* ChatroomLine[CHATROOM_MAXLINES];
COLOR* ChatroomLineColors[CHATROOM_MAXLINES];

STRING* Chatroom_MessageLine="#500";



int returnOwnedPlayerId()
{
	int i=-1;
	
	while (i++<MAXPLAYERS)
		if (Player[i]->owner==OWNER_PLAYER && str_cmpi(clientNames[i],player_name)) return i;
		
	return NOPLAYERID;
}

void EnterLineAtChatroom(char* line,COLOR* color)
{
	int i;
	
	for (i=0;i<CHATROOM_MAXLINES-2;i++)
	{
		str_cpy(ChatroomLine[i],ChatroomLine[i+1]);
		vec_set(ChatroomLineColors[i],ChatroomLineColors[i+1]);
	}
	
	str_cpy(ChatroomLine[CHATROOM_MAXLINES-2],line);
	vec_set(ChatroomLineColors[CHATROOM_MAXLINES-2],color);
}


	
STRING* input_str = "#500";

void UserInputToMessageLineUpdate()
{
	while (1)
	{
		inkey(input_str); // read user's keyboard input and store it inside input_str
		//error(str_for_num(NULL,result));
		if (result == 13) //ENTER
		{
			str_cpy(sNetworkString,player_name);
			str_cat(sNetworkString,": ");
			str_cat(sNetworkString,input_str);
			
			str_cpy(input_str,"#500");
			
			vNetworkParameter1=returnOwnedPlayerId();
			
			if (connection==2)
			{
				vNetworkMessage=NETWORK_REQUESTTOSENDMESSAGE;
				
				send_var(vNetworkParameter1);
				send_string(sNetworkString);
				send_var(vNetworkMessage);
				
				vNetworkMessage=NETWORK_NULL;
				vNetworkParameter1=NETWORK_NULL;
				str_cpy(sNetworkString,"#500");
			}
			else
			{
				EnterLineAtChatroom(sNetworkString,ChatroomLineColors[CHATROOM_MAXLINES-1]);
				
				vNetworkMessage=NETWORK_POSTMESSAGE;
				
				send_var(vNetworkParameter1);
				send_string(sNetworkString);
				send_var(vNetworkMessage);
				
				vNetworkMessage=NETWORK_NULL;
				vNetworkParameter1=NETWORK_NULL;
				str_cpy(sNetworkString,"#500");
			}
			
		}
		else if (result == 59)	//F1
			Player1Button();
		else if (result == 60)	//F2
			Player2Button();
		else if (result == 61)	//F3
			Player3Button();
		else if (result == 62)	//F4
			Player4Button();
			
		else if (result == 63) //F5
			ToggleStart();
		//else if (result == 64) //F6
			//ToggleAreaSize();
		//else if (result == 65) //F7
			//ToggleRounds();
		//else if (result == 66)	//F8
		//	xxxxxx();
		
		else if (result == 27) //ESC
			HandleEscape();
			
		
		wait(1);
	}
}


void Chatroom()
{
	//Init
	int i,plrId;
	
	//Create Chatroom Objects
	for (i=0;i<CHATROOM_MAXLINES;i++)
	{
		ChatroomLine[i]=str_create("#500");
		str_cpy(ChatroomLine[i],"");
		ChatroomLineColors[i]=new(COLOR);
		vec_set(ChatroomLineColors[i],vector(255,255,255));
	}
	
	//Setup Chatroom Font
	draw_textmode("Times",0,19,100);	//Remove from here if i decide to use a different font for other draw_text stuff
	
	UserInputToMessageLineUpdate();
	
	//Loop
	while (1)
	{
		//Draw Chatroom Box
		ix_draw_line2d(vector(screen_size.x*0.01,screen_size.y*0.74,0),vector(screen_size.x*0.99,screen_size.y*0.74,0),vector(0,0,255));	//upper left to upper right
		ix_draw_line2d(vector(screen_size.x*0.01,screen_size.y*0.74,0),vector(screen_size.x*0.01,screen_size.y*0.975,0),vector(0,0,255));	//upper left to bottom left
		ix_draw_line2d(vector(screen_size.x*0.99,screen_size.y*0.74,0),vector(screen_size.x*0.99,screen_size.y*0.975,0),vector(0,0,255));	//upper right to bottom right
		ix_draw_line2d(vector(screen_size.x*0.01,screen_size.y*0.94,0),vector(screen_size.x*0.99,screen_size.y*0.94,0),vector(0,0,255));	//middle bottom left to middle bottom right
		ix_draw_line2d(vector(screen_size.x*0.01,screen_size.y*0.975,0),vector(screen_size.x*0.99,screen_size.y*0.975,0),vector(0,0,255));	//bottom left to bottom right
		
		//Setup Chatroom Font
		//draw_textmode("Times",0,18,100);	//enable back if i decide to use a different font for other draw_text stuff
		
		//Draw History Text Lines
		for (i=0;i<CHATROOM_MAXLINES-1;i++) draw_text(ChatroomLine[i],screen_size.x*0.015,screen_size.y*0.74+i*20, ChatroomLineColors[i]);
		
		//Draw Message Text Line
		str_cpy(ChatroomLine[i],player_name);
		str_cat(ChatroomLine[i],": ");
		str_cat(ChatroomLine[i],input_str);
		plrId=returnOwnedPlayerId();
		if (plrId==NOPLAYERID) vec_set(ChatroomLineColors[i],vector(255,255,255));
			else vec_set(ChatroomLineColors[i],PlayerData[plrId*MAXPLAYERDATA+PLAYERDATA_TEXTCOLOUR]);
			
		draw_text(ChatroomLine[i],screen_size.x*0.015,screen_size.y*0.74+i*20, ChatroomLineColors[i]);  //19.8
		
		
		
		wait(1);
	}
}



TEXT* txtTitle =	
{
  layer = 1;
  string = "Atoms";
  font = "Arial#55b";
  red = 58;
  green = 205;
  blue = 202;
  flags = CENTER_X | CENTER_Y | FILTER;// | SHADOW | OUTLINE;
}

STRING* sPlayer1 = "#100";

TEXT* txtPlayer1 =	
{
  layer = 1;
  string = sPlayer1;
  font = "Arial#18b";
  red = 255;
  green = 255;
  blue = 0;
  flags = FILTER;
}

STRING* sPlayer2 = "#100";

TEXT* txtPlayer2 =	
{
  layer = 1;
  string = sPlayer2;
  font = "Arial#18b";
  red = 255;
  green = 0;
  blue = 0;
  flags = FILTER;
}

STRING* sPlayer3 = "#100";

TEXT* txtPlayer3 =	
{
  layer = 1;
  string = sPlayer3;
  font = "Arial#18b";
  red = 0;
  green = 0;
  blue = 255;
  flags = FILTER;
}

STRING* sPlayer4 = "#100";

TEXT* txtPlayer4 =	
{
  layer = 1;
  string = sPlayer4;
  font = "Arial#18b";
  red = 0;
  green = 255;
  blue = 0;
  flags = FILTER;
}

STRING* sInstructions = "#100";

TEXT* txtInstructions =	
{
  layer = 1;
  string = sInstructions;
  font = "Arial#30b";
  red = 255;
  green = 128;
  blue = 0;
  flags = CENTER_X | CENTER_Y | FILTER;// | SHADOW | OUTLINE;
}

	
void StaticInterface()
{
	//INIT
	int i,j;
	
	//Title
	txtTitle.pos_x=screen_size.x*0.22;
	txtTitle.pos_y=screen_size.y*0.05;
	set(txtTitle,SHOW);

	//Player1
	txtPlayer1.pos_x=screen_size.x*0.02;
	txtPlayer1.pos_y=screen_size.y*0.24;
	set(txtPlayer1,SHOW);
	
	//Player2
	txtPlayer2.pos_x=screen_size.x*0.02;
	txtPlayer2.pos_y=screen_size.y*0.34;
	set(txtPlayer2,SHOW);
	
	//Player3
	txtPlayer3.pos_x=screen_size.x*0.02;
	txtPlayer3.pos_y=screen_size.y*0.44;
	set(txtPlayer3,SHOW);
	
	//Player4
	txtPlayer4.pos_x=screen_size.x*0.02;
	txtPlayer4.pos_y=screen_size.y*0.54;
	set(txtPlayer4,SHOW);
	
	//Start Game
	txtInstructions.pos_x=screen_size.x*0.22;
	txtInstructions.pos_y=screen_size.y*0.63;
	set(txtInstructions,SHOW);
	
	//Start Chatroom
	Chatroom();
	
	
	
	//LOOP
	while (1)
	{
		if (iGameState==GAMESTATE_MAINMENU)
		{
			str_cpy(sInstructions,"Press F5 to start!");
			txtInstructions.pos_x=screen_size.x*0.22;
			txtInstructions.pos_y=screen_size.y*0.63;
		}
		else
		{
			//Detect Victory
			j=0;
			for (i=0;i<MAXPLAYERS;i++)
				if (Player[i]->owner!=OWNER_NONE)
					if (countAtoms(i)>0) j++;
			
			if (j<2 && GameInitiating==FALSE)
			{
				str_cpy(sInstructions,"Press ESC to play again!");
				txtInstructions.pos_x=screen_size.x*0.22;
				txtInstructions.pos_y=screen_size.y*0.63;
			}
			else
			{
				str_cpy(sInstructions,"");
			}

		}
		
		wait(1);
	}
	
	//EXIT
}



void StartMainMenu()
{
	//INIT
	iGameState=GAMESTATE_MAINMENU;
	
	int i;
	
	//Reset Player Data
	for (i=0;i<MAXPLAYERS;i++)
	{
		Player[i]->owner=OWNER_NONE;
		str_cpy(clientNames[i],"#100");
		
		str_cpy(sTxtPlayer[i],sStaticPlayerText[i]);
		str_cat(sTxtPlayer[i],": Press F");
		str_cat(sTxtPlayer[i],str_for_num(NULL,i+1));
		str_cat(sTxtPlayer[i]," to Join!");
	}
	
	activePlayers=0;
	
	//Create New Level
	CreateNewLevel();
	
	//Set Camera
	vec_set(camera.x,vector(-207,89,-784));
	vec_set(camera.pan,vector(90,90,0));
	
	
	//LOOP
	while (iGameState==GAMESTATE_MAINMENU)
	{
		//Draw Field
		Draw3dField(AreaSizeXY[Aindex][POS_X],AreaSizeXY[Aindex][POS_Y],CENTERPOS,SQUARESIZE,vector(0,0,255));
		
		for (i=0;i<MAXPLAYERS;i++)
		{
			//Edit String
			if (Player[i]->owner==OWNER_PLAYER)
			{
				str_cpy(sTxtPlayer[i],sStaticPlayerText[i]);
				str_cat(sTxtPlayer[i],": Human (");
				str_cat(sTxtPlayer[i],clientNames[i]);
				str_cat(sTxtPlayer[i],")");
			}
			else if (Player[i]->owner==OWNER_COMPUTER)
			{
				str_cpy(sTxtPlayer[i],sStaticPlayerText[i]);
				str_cat(sTxtPlayer[i],": Computer");
			}
			else
			{
				str_cpy(sTxtPlayer[i],sStaticPlayerText[i]);
				str_cat(sTxtPlayer[i],": Press F");
				str_cat(sTxtPlayer[i],str_for_num(NULL,i+1));
				str_cat(sTxtPlayer[i]," to Join!");
			}
		}
	
	
		wait(1);
	}
}

void StartInGame()
{
	//INIT
	int i;
	GameInitiating=TRUE;
	iGameState=GAMESTATE_INGAME;
	
	//Create New Level
	CreateNewLevel();
	
	//Set Camera
	vec_set(camera.x,vector(-207,89,-784));
	vec_set(camera.pan,vector(90,90,0));
	
	//Clean Field Arrays
	CleanFieldArrays();
	
	//Clear Queue Arrays	(may lag)
	clearArray(AddAtom_X_Queue,QUEUE_SIZE,INVALID);
	clearArray(AddAtom_Y_Queue,QUEUE_SIZE,INVALID);
	clearArray(AddAtom_pID_Queue,QUEUE_SIZE,INVALID);
	
	wait(10);
	//For all players. Only Loop through each player Once. For a constant loop look below
	for (i=0;i<MAXPLAYERS;i++)
	{
		//Set Player Text that is not participating in the game to invisible ("")
		if (Player[i]->owner==OWNER_NONE) str_cpy(sTxtPlayer[i],"");
		
		//set all players to alive(just make sure to remove the ones without any owners)
		Player[i]->alive=TRUE;
		
		//add the initial corner atoms
		if (connection!=2)
		{
			if (Player[i]->owner!=OWNER_NONE)
			{
				if (i==0)
				{
					CreateNewAtomAt(0,0,i);
					
					vNetworkMessage=NETWORK_CREATEATOM;
					vNetworkParameter1=0;
					vNetworkParameter2=0;
					vNetworkParameter3=i;
					
					send_var(vNetworkParameter1);
					send_var(vNetworkParameter2);
					send_var(vNetworkParameter3);
					send_var(vNetworkMessage);
					
					vNetworkMessage=NETWORK_NULL;
					vNetworkParameter1=NETWORK_NULL;
					vNetworkParameter2=NETWORK_NULL;
					vNetworkParameter3=NETWORK_NULL;
				}
				
				else if (i==1)
				{
					CreateNewAtomAt(AreaSizeXY[Aindex][POS_X]-1,0,i);
					
					vNetworkMessage=NETWORK_CREATEATOM;
					vNetworkParameter1=AreaSizeXY[Aindex][POS_X]-1;
					vNetworkParameter2=0;
					vNetworkParameter3=i;
					
					send_var(vNetworkParameter1);
					send_var(vNetworkParameter2);
					send_var(vNetworkParameter3);
					send_var(vNetworkMessage);
					
					vNetworkMessage=NETWORK_NULL;
					vNetworkParameter1=NETWORK_NULL;
					vNetworkParameter2=NETWORK_NULL;
					vNetworkParameter3=NETWORK_NULL;
				}
				
				else if (i==2)
				{
					CreateNewAtomAt(0,AreaSizeXY[Aindex][POS_Y]-1,i);
					
					vNetworkMessage=NETWORK_CREATEATOM;
					vNetworkParameter1=0;
					vNetworkParameter2=AreaSizeXY[Aindex][POS_Y]-1;
					vNetworkParameter3=i;
					
					send_var(vNetworkParameter1);
					send_var(vNetworkParameter2);
					send_var(vNetworkParameter3);
					send_var(vNetworkMessage);
					
					vNetworkMessage=NETWORK_NULL;
					vNetworkParameter1=NETWORK_NULL;
					vNetworkParameter2=NETWORK_NULL;
					vNetworkParameter3=NETWORK_NULL;
				}
				
				else if (i==3)
				{
					CreateNewAtomAt(AreaSizeXY[Aindex][POS_X]-1,AreaSizeXY[Aindex][POS_Y]-1,i);
					
					vNetworkMessage=NETWORK_CREATEATOM;
					vNetworkParameter1=AreaSizeXY[Aindex][POS_X]-1;
					vNetworkParameter2=AreaSizeXY[Aindex][POS_Y]-1;
					vNetworkParameter3=i;
					
					send_var(vNetworkParameter1);
					send_var(vNetworkParameter2);
					send_var(vNetworkParameter3);
					send_var(vNetworkMessage);
					
					vNetworkMessage=NETWORK_NULL;
					vNetworkParameter1=NETWORK_NULL;
					vNetworkParameter2=NETWORK_NULL;
					vNetworkParameter3=NETWORK_NULL;
				}
			}
		}
	}
	
	//Make sure Everyone has gotten their initial atom
	int StartingPlayer=0;
	while (Player[StartingPlayer]->owner==OWNER_NONE || Player[StartingPlayer]->alive==FALSE) StartingPlayer++;
	while (countAtoms(StartingPlayer)==0) wait(1);
	GameInitiating=FALSE;
	
	//Figure out who should take the fist turn
	if (connection!=2)
	{
		PlayersTurn=-1;
		PlayersTurn=NextPlayerTurn(PlayersTurn);
		send_var(PlayersTurn);
	}
	
	//LOOP
	while (iGameState==GAMESTATE_INGAME)
	{
		//Draw Field
		Draw3dField(AreaSizeXY[Aindex][POS_X],AreaSizeXY[Aindex][POS_Y],CENTERPOS,SQUARESIZE,vector(0,0,255));
		
		//Display how many atoms each player has
		for (i=0;i<MAXPLAYERS;i++)
		{
			if (Player[i]->owner!=OWNER_NONE)
			{
				if (i==PlayersTurn) str_cpy(sTxtPlayer[i],"* "); else str_cpy(sTxtPlayer[i],"");
				str_cat(sTxtPlayer[i],sStaticPlayerText[i]);
				str_cat(sTxtPlayer[i],": (");
				str_cat(sTxtPlayer[i],str_for_num(NULL,countAtoms(i)));
				str_cat(sTxtPlayer[i],") Atoms Left!");
				//if (i==PlayersTurn) str_cat(sTxtPlayer[i]," *");
			}
		}
		
		
		//If it's computer's turn on server-side
		if (Player[PlayersTurn]->owner==OWNER_COMPUTER && connection!=2)
		{
			//If you own no atoms. skip his turn(also should mark him dead)
			if (countAtoms(PlayersTurn)==0)
			{
				PlayersTurn=NextPlayerTurn(PlayersTurn);
				send_var(PlayersTurn);
			}
			else
			{
				//Play Ai Turn
				CalculateAiMove();
			}
		}
		//If it's a human player's turn on server-side
		else if (Player[PlayersTurn]->owner==OWNER_PLAYER && connection!=2)
		{
			//If you own no atoms. skip his turn(also should mark him dead)
			if (countAtoms(PlayersTurn)==0)
			{
				PlayersTurn=NextPlayerTurn(PlayersTurn);
				send_var(PlayersTurn);
			}
		}
		
		wait(1);
	}
}






void main()
{
	video_window(NULL,NULL,114,"Atoms v1.0 by Intense Illusions");
	
	dplay_localfunction=2;
	
	video_aspect = 4/3; // enforce 4:3 mode
	video_mode=7;
	video_screen=2;
	
	setHeuristicTemplates();
	
	//Set Antialias Stuff
	d3d_antialias = 9;
	d3d_anisotropy = 2;
	
	//Sky
	sky_color.red = 1;
	sky_color.green = 1;
	sky_color.blue = 1; 
	
	//Inits
	randomize();
	InitArraySizes();
	
	//Mouse
	mouse_mode=4;  
	//mouse_pointer=0;
	
	if (connection==0) str_cpy(player_name,"Local");

	//Assign Players to an array
	Player[0]=&Player1;
	Player[1]=&Player2;
	Player[2]=&Player3;
	Player[3]=&Player4;
	clientNames[0]=Player1Name;
	clientNames[1]=Player2Name;
	clientNames[2]=Player3Name;
	clientNames[3]=Player4Name;
	sStaticPlayerText[0]=sStaticTxtPlayer1;
	sStaticPlayerText[1]=sStaticTxtPlayer2;
	sStaticPlayerText[2]=sStaticTxtPlayer3;
	sStaticPlayerText[3]=sStaticTxtPlayer4;
	sTxtPlayer[0]=sPlayer1;
	sTxtPlayer[1]=sPlayer2;
	sTxtPlayer[2]=sPlayer3;
	sTxtPlayer[3]=sPlayer4;
	
	on_server = server_event;
	on_client = client_event;
	on_mouse_left=HandleMouseLeft;
	
	
	clearArray(AddAtom_X_Queue,QUEUE_SIZE,INVALID);
	clearArray(AddAtom_Y_Queue,QUEUE_SIZE,INVALID);
	clearArray(AddAtom_pID_Queue,QUEUE_SIZE,INVALID);
	
	wait(4);	//wait a bit before sending the first network request, otherwise it might not get sent at all
	
	if (connection==2)
	{
		vNetworkMessage=NETWORK_REQUESTPLAYERSTRUCTS;
		send_var(vNetworkMessage);
		vNetworkMessage = NETWORK_NULL;
	}
	
	StartMainMenu();
	
	StaticInterface();	//NOTE!!!!!!!!!!!!!!!!!!!---->move the player text relevant stuff in THIS function
	
	
	//Add Atoms Instructions
	EnterLineAtChatroom("Welcome to Atoms!",vector(255,255,255));
	EnterLineAtChatroom("To win this game, you must conquer the board by placing atoms at strategic positions.",vector(255,255,255));
	EnterLineAtChatroom("You can play against the computer or against other friends on the same pc or over the Internet / LAN.",vector(255,255,255));
	EnterLineAtChatroom("To add players in the game use the keys F1 to F4. Press once for human, twice for computer and three times to re-open the slot.",vector(255,255,255));
	EnterLineAtChatroom("For instructions on how to play the game or how to play over the Internet / LAN, see the Readme File.",vector(255,255,255));
	EnterLineAtChatroom("A minimum of two players (human or computer) are required. To start the game press F5. N 'joy!",vector(255,255,255));
	
	
	
	
	
	
	//SET UP KEYS
	/*
	on_f1=NULL;
	on_f2=NULL;
	on_f3=NULL;
	on_f4=NULL;
	//on_f5=NULL;  //Resolution Change (temporary)
	//on_f6=NULL;	//Screen Capture
	on_f7=ToggleAreaSize;
	on_f8=ToggleStart;
	//on_f9=NULL;
	//on_f10=NULL;
	//on_f11=NULL;	//Debug info
	on_f12=NULL;	//ToggleRounds
	on_esc=HandleEscape;
	*/
	
	//Create MainScreen Bitmap and Sounds
	//bMScreen = bmap_createblack(screen_size.x,screen_size.y,16);
	//on_enter=CalculateAiMove;
	//on_u=IMMove_CopyField;
	//debug_VisualGrid1();
	//debug_VisualGrid2();
	//on_mouse_right=HandleMouseRight;
}





//////////////////////START OF AI//////////////////////////////




void setHeuristicTemplates()
{
	//Set Normal Heuristic Template
	IMh[hAtomsInCell_l][HeuristicSet_Normal]=15;
	IMh[hAtomsInCell_h][HeuristicSet_Normal]=30;
	IMh[hNeighborOwnedSquares_l][HeuristicSet_Normal]=10;
	IMh[hNeighborOwnedSquares_h][HeuristicSet_Normal]=20;
	IMh[hNeighborOwnedSquaresPenalty_l][HeuristicSet_Normal]=-2;
	IMh[hNeighborOwnedSquaresPenalty_h][HeuristicSet_Normal]=-1;
	IMh[hNeighborOwnedSquaresMinimum_l][HeuristicSet_Normal]=3;
	IMh[hNeighborOwnedSquaresMinimum_h][HeuristicSet_Normal]=5;
	IMh[hBorderedEdges_l][HeuristicSet_Normal]=5;
	IMh[hBorderedEdges_h][HeuristicSet_Normal]=10;
	IMh[hDiagonalNeighbors_l][HeuristicSet_Normal]=8;
	IMh[hDiagonalNeighbors_h][HeuristicSet_Normal]=18;
	IMh[hDiagonalNeighborsBonus_l][HeuristicSet_Normal]=1;
	IMh[hDiagonalNeighborsBonus_h][HeuristicSet_Normal]=2;
	IMh[hNextToOneNeighbors_l][HeuristicSet_Normal]=10;
	IMh[hNextToOneNeighbors_h][HeuristicSet_Normal]=20;
	IMh[hNextToOneNeighborsBonus_l][HeuristicSet_Normal]=1;
	IMh[hNextToOneNeighborsBonus_h][HeuristicSet_Normal]=2;
	IMh[hNoOpponentNeighbors_l][HeuristicSet_Normal]=2;
	IMh[hNoOpponentNeighbors_h][HeuristicSet_Normal]=5;
	IMh[hNoOpponentNeighborsExplodeBonus_l][HeuristicSet_Normal]=15;
	IMh[hNoOpponentNeighborsExplodeBonus_h][HeuristicSet_Normal]=30;
	IMh[hNeighborOpponentReadyToExplode_l][HeuristicSet_Normal]=-100;
	IMh[hNeighborOpponentReadyToExplode_h][HeuristicSet_Normal]=-50;
	IMh[hNeighborOpponentReadyToExplodeBonus_l][HeuristicSet_Normal]=-30;
	IMh[hNeighborOpponentReadyToExplodeBonus_h][HeuristicSet_Normal]=-10;
	IMh[hReadyToExplodeWithOpponentNeighbors_l][HeuristicSet_Normal]=50;
	IMh[hReadyToExplodeWithOpponentNeighbors_h][HeuristicSet_Normal]=100;
	IMh[hReadyToExplodeWithOpponentNeighborsBonus_l][HeuristicSet_Normal]=10;
	IMh[hReadyToExplodeWithOpponentNeighborsBonus_h][HeuristicSet_Normal]=30;
	IMh[hEnemyClosestToExplosionPenalty_l][HeuristicSet_Normal]=-50;
	IMh[hEnemyClosestToExplosionPenalty_h][HeuristicSet_Normal]=-40;
	IMh[hMeClosestToExplosionBonus_l][HeuristicSet_Normal]=40;
	IMh[hMeClosestToExplosionBonus_h][HeuristicSet_Normal]=60;
}

int IsInBounds(int PosX,int PosY)
{
	if (PosX>=0 && PosY>=0 && PosX<AreaSizeXY[Aindex][POS_X] && PosY<AreaSizeXY[Aindex][POS_Y]) return TRUE;
		else return FALSE;
}

int AtomsNeededtoExplode(int PosX,int PosY,int Atoms)
{
	int Overflow=0;
	
	if (IsInBounds(PosX-1,PosY)==FALSE) Overflow++;
	if (IsInBounds(PosX,PosY-1)==FALSE) Overflow++;
	if (IsInBounds(PosX+1,PosY)==FALSE) Overflow++;
	if (IsInBounds(PosX,PosY+1)==FALSE) Overflow++;
	Overflow+=Atoms;
	
	return (4-Overflow);
}

//dArrayOwners
//dArrayAtoms
int IMMove_InfluenceMap_Score(int plrID,int hs)
{
	int i,j,k,l,counter,counter2,temp;
	int Score=0;

	for (i=0;i<AreaSizeXY[Aindex][POS_X];i++)
		for (j=0;j<AreaSizeXY[Aindex][POS_Y];j++)
		{
			//INDIVIDUAL SQUARE EVALUATION START
			
			//If I own this square
			if (dArrayOwners[i][j]==plrID)
			{
				//Owned atoms in square
				Score+=dArrayAtoms[i][j]*ix_IntRandom(IMh[hAtomsInCell_l][hs],IMh[hAtomsInCell_h][hs]);
				
				//Immediate Neighbor Squares owned by me (including diagonal)
				counter=0;
				for (k=-1;k<=1;k++)
					for (l=-1;l<=1;l++)
						if (k!=0 || l!=0)
							if (IsInBounds(i+k,j+l)) //Check if square examined is valid
								if (dArrayOwners[i+k][j+l]==plrID)
									counter++;
				
				if (counter>0)
				{
					temp=ix_IntRandom(IMh[hNeighborOwnedSquares_l][hs],IMh[hNeighborOwnedSquares_h][hs]);
					temp-=counter*ix_IntRandom(IMh[hNeighborOwnedSquaresPenalty_l][hs],IMh[hNeighborOwnedSquaresPenalty_h][hs]);
					temp=maxv(temp,ix_IntRandom(IMh[hNeighborOwnedSquaresMinimum_l][hs],IMh[hNeighborOwnedSquaresMinimum_h][hs]));
					Score+=temp;
				}
				
				//Bordered Edges
				counter=0;
				if (IsInBounds(i-1,j)==FALSE) counter++;
				if (IsInBounds(i,j-1)==FALSE) counter++;
				if (IsInBounds(i+1,j)==FALSE) counter++;
				if (IsInBounds(i,j+1)==FALSE) counter++;
				Score+=counter*ix_IntRandom(IMh[hBorderedEdges_l][hs],IMh[hBorderedEdges_h][hs]);
				
				
				//Diagonal Squares owned by opponents
				counter=0;
				if (IsInBounds(i-1,j-1)==TRUE) if (dArrayOwners[i-1][j-1]!=plrID && dArrayOwners[i-1][j-1]!=NOPLAYERID) counter++;
				if (IsInBounds(i-1,j+1)==TRUE) if (dArrayOwners[i-1][j+1]!=plrID && dArrayOwners[i-1][j+1]!=NOPLAYERID) counter++;
				if (IsInBounds(i+1,j-1)==TRUE) if (dArrayOwners[i+1][j-1]!=plrID && dArrayOwners[i+1][j-1]!=NOPLAYERID) counter++;
				if (IsInBounds(i+1,j+1)==TRUE) if (dArrayOwners[i+1][j+1]!=plrID && dArrayOwners[i+1][j+1]!=NOPLAYERID) counter++;
				
				if (counter>0)
				{
					temp=ix_IntRandom(IMh[hDiagonalNeighbors_l][hs],IMh[hDiagonalNeighbors_h][hs]);
					temp+=counter*ix_IntRandom(IMh[hDiagonalNeighborsBonus_l][hs],IMh[hDiagonalNeighborsBonus_h][hs]);
					Score+=temp;
				}
				
				
				//Next to one opponent neighbor squares
				counter=0;
				for (k=-2;k<=2;k++)
					for (l=-2;l<=2;l++)
						if (k==2 || l==2)
							if (IsInBounds(i+k,j+l)) //Check if square examined is valid
								if (dArrayOwners[i+k][j+l]!=plrID && dArrayOwners[i+k][j+l]!=NOPLAYERID)
								{
									if (k==-2)
									{
										if (k==-2 && l==-2 && dArrayOwners[i-1][j-1]==NOPLAYERID) {counter++; continue;}
										if (k==-2 && l==0 && dArrayOwners[i-1][j]==NOPLAYERID) {counter++; continue;}
										if (k==-2 && l==2 && dArrayOwners[i-1][j+1]==NOPLAYERID) {counter++; continue;}
										if (k==-2 && l==-1 && dArrayOwners[i-1][j-1]==NOPLAYERID && dArrayOwners[i-1][j]==NOPLAYERID) {counter++; continue;}
										if (k==-2 && l==1 && dArrayOwners[i-1][j+1]==NOPLAYERID && dArrayOwners[i-1][j]==NOPLAYERID) {counter++; continue;}
									}
									else if (k==0)
									{
										if (k==0 && l==-2 && dArrayOwners[i][j-1]==NOPLAYERID) {counter++; continue;}
										if (k==0 && l==2 && dArrayOwners[i][j+1]==NOPLAYERID) {counter++; continue;}
									}
									else if (k==2)
									{
										if (k==2 && l==2 && dArrayOwners[i+1][j+1]==NOPLAYERID) {counter++; continue;}
										if (k==2 && l==0 && dArrayOwners[i+1][j]==NOPLAYERID) {counter++; continue;}
										if (k==2 && l==-2 && dArrayOwners[i+1][j-1]==NOPLAYERID) {counter++; continue;}
										if (k==2 && l==-1 && dArrayOwners[i+1][j-1]==NOPLAYERID && dArrayOwners[i+1][j]==NOPLAYERID) {counter++; continue;}
										if (k==2 && l==1 && dArrayOwners[i+1][j+1]==NOPLAYERID && dArrayOwners[i+1][j]==NOPLAYERID) {counter++; continue;}
									}
									else
									{
										if (k==-1 && l==-2 && dArrayOwners[i-1][j-1]==NOPLAYERID && dArrayOwners[i][j-1]==NOPLAYERID) {counter++; continue;}
										if (k==1 && l==-2 && dArrayOwners[i+1][j-1]==NOPLAYERID && dArrayOwners[i][j-1]==NOPLAYERID) {counter++; continue;}
										if (k==-1 && l==2 && dArrayOwners[i-1][j+1]==NOPLAYERID && dArrayOwners[i][j+1]==NOPLAYERID) {counter++; continue;}
										if (k==1 && l==2 && dArrayOwners[i+1][j+1]==NOPLAYERID && dArrayOwners[i][j+1]==NOPLAYERID) {counter++; continue;}
									}
								}
									
				
				if (counter>0)
				{
					temp=ix_IntRandom(IMh[hNextToOneNeighbors_l][hs],IMh[hNextToOneNeighbors_h][hs]);
					temp+=counter*ix_IntRandom(IMh[hNextToOneNeighborsBonus_l][hs],IMh[hNextToOneNeighborsBonus_h][hs]);
					Score+=temp;
				}
				
				//Opponent Neighbors
				counter=0;
				if (IsInBounds(i-1,j)==TRUE) if (dArrayOwners[i-1][j]!=plrID && dArrayOwners[i-1][j]!=NOPLAYERID) counter++;
				if (IsInBounds(i,j-1)==TRUE) if (dArrayOwners[i][j-1]!=plrID && dArrayOwners[i][j-1]!=NOPLAYERID) counter++;
				if (IsInBounds(i+1,j)==TRUE) if (dArrayOwners[i+1][j]!=plrID && dArrayOwners[i+1][j]!=NOPLAYERID) counter++;
				if (IsInBounds(i,j+1)==TRUE) if (dArrayOwners[i][j+1]!=plrID && dArrayOwners[i][j+1]!=NOPLAYERID) counter++;
				
				if (counter==0) //No opponent neighbors
				{
					Score+=ix_IntRandom(IMh[hNoOpponentNeighbors_l][hs],IMh[hNoOpponentNeighbors_h][hs]);
					if (AtomsNeededtoExplode(i,j,dArrayAtoms[i][j])==1) Score+=ix_IntRandom(IMh[hNoOpponentNeighborsExplodeBonus_l][hs],IMh[hNoOpponentNeighborsExplodeBonus_h][hs]);
				}
				else	//Opponent neighbors present
				{
					counter2=0;
					if (IsInBounds(i-1,j)==TRUE) if (dArrayOwners[i-1][j]!=plrID && dArrayOwners[i-1][j]!=NOPLAYERID && AtomsNeededtoExplode(i-1,j,dArrayAtoms[i-1][j])==1) counter2++;
					if (IsInBounds(i,j-1)==TRUE) if (dArrayOwners[i][j-1]!=plrID && dArrayOwners[i][j-1]!=NOPLAYERID && AtomsNeededtoExplode(i,j-1,dArrayAtoms[i][j-1])==1) counter2++;
					if (IsInBounds(i+1,j)==TRUE) if (dArrayOwners[i+1][j]!=plrID && dArrayOwners[i+1][j]!=NOPLAYERID && AtomsNeededtoExplode(i+1,j,dArrayAtoms[i+1][j])==1) counter2++;
					if (IsInBounds(i,j+1)==TRUE) if (dArrayOwners[i][j+1]!=plrID && dArrayOwners[i][j+1]!=NOPLAYERID && AtomsNeededtoExplode(i,j+1,dArrayAtoms[i][j+1])==1) counter2++;
					
					if (counter2>0) //If there's at least one opponent neighbor square ready to explode
					{
						Score+=ix_IntRandom(IMh[hNeighborOpponentReadyToExplode_l][hs],IMh[hNeighborOpponentReadyToExplode_h][hs]);
						if (counter2-1>0) Score+=(counter2-1)*ix_IntRandom(IMh[hNeighborOpponentReadyToExplodeBonus_l][hs],IMh[hNeighborOpponentReadyToExplodeBonus_h][hs]);
					}
					else //If there's no opponent neighbor squares ready to explode (but there ARE opponent neighbors present)
					{
						if (AtomsNeededtoExplode(i,j,dArrayAtoms[i][j])==1)	//my square is ready to explode
						{
							Score+=ix_IntRandom(IMh[hReadyToExplodeWithOpponentNeighbors_l][hs],IMh[hReadyToExplodeWithOpponentNeighbors_h][hs]);
							if (counter-1>0) Score+=(counter-1)*ix_IntRandom(IMh[hReadyToExplodeWithOpponentNeighborsBonus_l][hs],IMh[hReadyToExplodeWithOpponentNeighborsBonus_h][hs]);
						}
						else	//my square is NOT ready to explode (and neither are my opponent neighbors' squares)
						{
							temp=1000;
							
							if (IsInBounds(i-1,j)==TRUE) if (dArrayOwners[i-1][j]!=plrID && dArrayOwners[i-1][j]!=NOPLAYERID) temp=minv(AtomsNeededtoExplode(i-1,j,dArrayAtoms[i-1][j]),temp);
							if (IsInBounds(i,j-1)==TRUE) if (dArrayOwners[i][j-1]!=plrID && dArrayOwners[i][j-1]!=NOPLAYERID) temp=minv(AtomsNeededtoExplode(i,j-1,dArrayAtoms[i][j-1]),temp);
							if (IsInBounds(i+1,j)==TRUE) if (dArrayOwners[i+1][j]!=plrID && dArrayOwners[i+1][j]!=NOPLAYERID) temp=minv(AtomsNeededtoExplode(i+1,j,dArrayAtoms[i+1][j]),temp);
							if (IsInBounds(i,j+1)==TRUE) if (dArrayOwners[i][j+1]!=plrID && dArrayOwners[i][j+1]!=NOPLAYERID) temp=minv(AtomsNeededtoExplode(i,j+1,dArrayAtoms[i][j+1]),temp);
							
							if (temp==1000) error("temp is 1000, there is a problem");
							temp-=AtomsNeededtoExplode(i,j,dArrayAtoms[i][j]); //now temp has a positive if i need less atoms than opponent to explode, and negative if i need more
							if (temp<=0) temp--;
							
							if (temp>0) Score+=temp*ix_IntRandom(IMh[hMeClosestToExplosionBonus_l][hs],IMh[hMeClosestToExplosionBonus_h][hs]); //i'm closest to explosion
								else Score+=temp*(-1)*ix_IntRandom(IMh[hEnemyClosestToExplosionPenalty_l][hs],IMh[hEnemyClosestToExplosionPenalty_h][hs]); //opponent closest to explosion
						}
					}
				}
				
				
				//
				//..
			}
			//If an opponent owns this square
			else if (dArrayOwners[i][j]!=NOPLAYERID)
			{
				
			}
			//If this square is empty
			else
			{
				
			}
			
			//INDIVIDUAL SQUARE EVALUATION END
		}
		
	
	return Score;
}


int IMMove_countAtoms(int par_playerId)
{
	int i,j;
	int AtomsCount=0;

	for (i=0;i<AreaSizeXY[Aindex][POS_X];i++)
		for (j=0;j<AreaSizeXY[Aindex][POS_Y];j++)
			if (dArrayOwners[i][j]==par_playerId) AtomsCount+=dArrayAtoms[i][j];
			
	return AtomsCount;
}


void IMMove_RemoveAtom(int posX,int posY)
{
	dArrayAtoms[posX][posY]-=1;
	if (dArrayAtoms[posX][posY]==0) dArrayOwners[posX][posY]=NOPLAYERID;
}


void IMMove_MoveAtom(int PosX,int PosY,int DirX,int DirY,par_playerId)
{
	IMMove_RemoveAtom(PosX,PosY);
	Queue_Push(AddAtom_X_Queue,PosX+DirX);
	Queue_Push(AddAtom_Y_Queue,PosY+DirY);
	Queue_Push(AddAtom_pID_Queue,par_playerId);
}


void IMMove_AddAtom(int posX,int posY,int par_playerId)
{
	//Add one atom to the new field
	dArrayAtoms[posX][posY]+=1;
	
	//If the new field was currently occupied by another player, or by no player
	if (dArrayOwners[posX][posY]!=par_playerId) dArrayOwners[posX][posY]=par_playerId;
	
	//If this field now has more atoms than it can afford
	int Overflow=0;
	if (posX==0) Overflow++;
	if (posY==0) Overflow++;
	if (posX==AreaSizeXY[Aindex][POS_X]-1) Overflow++;
	if (posY==AreaSizeXY[Aindex][POS_Y]-1) Overflow++;
	Overflow+=dArrayAtoms[posX][posY];
	
	if (Overflow>3)
	{
		if (posX!=0) IMMove_MoveAtom(posX,posY,-1,0,par_playerId);
		if (posY!=0) IMMove_MoveAtom(posX,posY,0,-1,par_playerId);
		if (posX!=AreaSizeXY[Aindex][POS_X]-1) IMMove_MoveAtom(posX,posY,1,0,par_playerId);
		if (posY!=AreaSizeXY[Aindex][POS_Y]-1) IMMove_MoveAtom(posX,posY,0,1,par_playerId);
	}
}


#define AIMOVE_GIVEUP_CUTOFF_VALUE 5000
#define AIMOVE_GIVEUP_SCORE 100000

int IMMove_ProcessQueue()
{
	int counter=0;
	
	while (!Queue_isEmpty(AddAtom_X_Queue))
	{
		IMMove_AddAtom(Queue_Pull(AddAtom_X_Queue),Queue_Pull(AddAtom_Y_Queue),Queue_Pull(AddAtom_pID_Queue));
		
		if (counter++>AIMOVE_GIVEUP_CUTOFF_VALUE) 
		{
			while (!Queue_isEmpty(AddAtom_X_Queue))
			{
				Queue_Pull(AddAtom_X_Queue);
				Queue_Pull(AddAtom_Y_Queue);
				Queue_Pull(AddAtom_pID_Queue);
			}
			//beep();
			return FALSE;
		}
	}
	
	return TRUE;
}


int IMMove_AiMove(int PosX,int PosY,int par_playerId)
{
	IMMove_AddAtom(PosX,PosY,par_playerId);	//Queue may be not empty after this instruction
	return IMMove_ProcessQueue();	//Queue is guaranteed to be empty after this instruction
}

void IMMove_CopyField()
{
	int i,j;
	
	for (i=0;i<AreaSizeXY[Aindex][POS_X];i++)
		for (j=0;j<AreaSizeXY[Aindex][POS_Y];j++)
		{
			IM1_FieldAtoms[i][j]=FieldAtoms[i][j];
			IM1_FieldOwners[i][j]=FieldOwners[i][j];
		}
}


void CalculateAiMove()
{
	int currentScore=INVALID;
	int BestScore=-999999;
	int BestScoreCell_PosX=INVALID;
	int BestScoreCell_PosY=INVALID;
	
	//if (PlayersTurn!=0) BestScore=999999; //deleteme
	
	if (!AreAtomsOnTheMove())
	{
		//Loop Through All Possible Moves
		int i,j;
		for (i=0;i<AreaSizeXY[Aindex][POS_X];i++)
			for (j=0;j<AreaSizeXY[Aindex][POS_Y];j++)
			{
				dArrayOwners2[i][j]=INVALID;	//DEBUG
				
				//If it's possible for the AI to add an atom in this cell
				if (FieldOwners[i][j]==PlayersTurn || FieldAtoms[i][j]<=0)
				{
					IMMove_CopyField();
					
					if (IMMove_AiMove(i,j,PlayersTurn)) currentScore=IMMove_InfluenceMap_Score(PlayersTurn,HeuristicSet_Normal);
						else currentScore=AIMOVE_GIVEUP_SCORE;
					
						//DEBUG!!!!
						dArrayAtoms2[i][j]=currentScore;
						//beep();
						//wait(-0.01);
						//END OF DEBUG!!!!
					
					//Store Best Score Cell
					/*
					if (PlayersTurn!=0) //deleteme
					{
						if (currentScore<=BestScore)
						{
							BestScore=currentScore;
							BestScoreCell_PosX=i;
							BestScoreCell_PosY=j;
						}
					}
					else
					{*/
						if (currentScore>=BestScore)
						{
							BestScore=currentScore;
							BestScoreCell_PosX=i;
							BestScoreCell_PosY=j;
						}
					//}
				} else dArrayAtoms2[i][j]=INVALID;	//DEBUG
			}
		
		dArrayOwners2[BestScoreCell_PosX][BestScoreCell_PosY]=1; //DEBUG	
		
		//Throw The Atom
		CreateNewAtomAt(BestScoreCell_PosX,BestScoreCell_PosY,PlayersTurn);
		
		vNetworkMessage=NETWORK_CREATEATOM;
		vNetworkParameter1=BestScoreCell_PosX;
		vNetworkParameter2=BestScoreCell_PosY;
		vNetworkParameter3=PlayersTurn;
		
		send_var(vNetworkParameter1);
		send_var(vNetworkParameter2);
		send_var(vNetworkParameter3);
		send_var(vNetworkMessage);
		
		vNetworkMessage=NETWORK_NULL;
		vNetworkParameter1=NETWORK_NULL;
		vNetworkParameter2=NETWORK_NULL;
		vNetworkParameter3=NETWORK_NULL;
		
		PlayersTurn=NextPlayerTurn(PlayersTurn);
		send_var(PlayersTurn);
	}
}


void debug_VisualGrid1()
{
	int StartPosX=1;
	int StartPosY=1;
	int FieldSpace=13;
	int i,j;
	
	while (1)
	{
		for (i=0;i<AreaSizeXY[Aindex][POS_X];i++)
			for (j=0;j<AreaSizeXY[Aindex][POS_Y];j++)
			{
				if (dArrayAtoms[i][j]==0) draw_text("0",StartPosX+i*FieldSpace,StartPosY+j*FieldSpace, vector(255,255,255));
					else draw_text(str_for_num(NULL,dArrayAtoms[i][j]),StartPosX+i*FieldSpace,StartPosY+j*FieldSpace, PlayerData[dArrayOwners[i][j]*MAXPLAYERDATA+PLAYERDATA_TEXTCOLOUR]);
			}
		
		wait(1);
	}
}


void debug_VisualGrid2()
{
	int StartPosX=1;
	int StartPosY=150;
	int FieldSpace=40;
	int i,j;

	while (1)
	{
		for (i=0;i<AreaSizeXY[Aindex][POS_X];i++)
			for (j=0;j<AreaSizeXY[Aindex][POS_Y];j++)
			{
				if (dArrayOwners2[i][j]==INVALID) draw_text(str_for_num(NULL,dArrayAtoms2[i][j]),StartPosX+i*FieldSpace,StartPosY+j*FieldSpace, vector(255,255,255));
					else draw_text(str_for_num(NULL,dArrayAtoms2[i][j]),StartPosX+i*FieldSpace,StartPosY+j*FieldSpace, PlayerData[dArrayOwners2[i][j]*MAXPLAYERDATA+PLAYERDATA_TEXTCOLOUR]);
			}
		
		wait(1);
	}
}

//AI Difficulty Levels:
//Marc Doofus
//Joe Average
//Albert Einstein
//////////////////////END OF AI////////////////////////////////
